* This RTS1 program first calculates a COPT capacity outage probability table from a Gdata input file.
* RTS1 reads the Gdata file containing 2 (or more states) generators.  Generators can have an additinoal 9
* states with the RTS1 program.  One of the multistate generators could be the ATC [MW,Pr] states of the ties.
* The hourly data is as before in the RTS program and contains the time stamp, demand, and variable resources.
* All the variables are given an identifier of 1 to mean area 1.  In RTS2 a 2nd area's variables will be added.
* RTS1 was Written by Gene Preston http://egpreston.com and last updated on December 15, 2016 with changes.
* You may use this program as you wish provided you agree your findings are entirely your responsibilty.
*
      CHARACTER C221*220,D221*220,C2*2,G1*32,H1*32                      ! C is the current data and D is the previous C, G1 = generator data, H1 = hourly data
      REAL F1(0:190000)/190001*0./,SF1(20),VR1(20),PCTC1(20),VRES1(20)  ! F is the capacity outage probability table COPT  PCTC=%capacity credit  VRES=VR energy by source on NSH1 days
      REAL LFU1(7,2)/.006,.061,.242,.382,.242,.061,.006,7*0./           ! load forecast uncertainty probabilities and per unit load adjustments
      REAL*8 LOLP1,LOLEAM1,LOLEPM1,LOLEV1,LOLH1,EUE1,ENGT1,VRE1,VREC1,  ! loss of load probability and expectation and loss of load hours are in double precision, total and variable resource energy
     & D1(19),DSF0/0.D0/,LOLE0/0.D0/,TLOLE1/0.D0/,DDSF/.02D0/,          ! D1( ) dummy variables  DSF0,LOLE0 = old values   LOLEAM1 is AM hours 1-12   LOLEPM1 is PM hours 13-24
     & LOLP24(24,2),PR1(12)                                             ! LOLP24 used to write to file 7, [OUT,PR] are [OutageMW,Pr] states of a multistate generator
      INTEGER IHA1/0/,IHB1/0/,JS/0/,MW(24,24),IP/0/,OUT1(12)            ! dummy hours used in LOLE AM PM tests, this line prevents a run time error  MW is for file 6 output  IP=0 do not print
      OPEN(5,FILE='OP.TXT')                                             ! open text output report file
      OPEN(6,FILE='OP.CSV')                                             ! open excel output report file
      OPEN(7,FILE='OPH.CSV')                                            ! we will write the houly LOLP's of significant days to this file
      WRITE(*,'(25HGENERATOR DATA FILE NAME:)')                         ! may I suggest you start with GDATA.txt
      READ(*,*) G1                                                      ! read generator file name, must be no longer than 32 characters
      WRITE(*,'(24HTARGET LOLE (OR RETURN):)')
      H1=' '
      READ(*,'(A32)') H1
      IF(H1.NE.' ') READ(H1,*) TLOLE1                                   ! target LOLE desired, the DSF (demand scale factor) is changed to converge to a desired LOLE
      IF(TLOLE1.LE.0.) IP=1                                             ! there is no iterating to a solution so print all lines
      OPEN(3,FILE=G1,STATUS='OLD',ERR=16)                               ! open the generator data file
      READ(3,'(A220)') C221                                             ! read the GDATA file title, note - any data beyond col 220 is skipped
      READ(3,*) H1                                                      ! read the HDATA file name
      WRITE(5,'(/13H GDATA File: ,A32                                   ! print the generator input data file name
     &          /13H HDATA File: ,A32                                   ! print the hourly input data file name
     &          //1X,A220)') G1,H1,C221                                 ! print the file names and the generation file title
      WRITE(6,'( 13H GDATA File: ,A32                                   ! print the generator input data file name
     &          /13H HDATA File: ,A32                                   ! print the hourly input data file name
     &          //A220)') G1,H1,C221                                    ! print the file names and the generation file title
      WRITE(7,'( 13H GDATA File: ,A32                                   ! print the generator input data file name
     &          /13H HDATA File: ,A32                                   ! print the hourly input data file name
     &          //A220)') G1,H1,C221                                    ! print the file names and the generation file title
      OPEN(4,FILE=H1,STATUS='OLD',ERR=17)                               ! open the hourly load and variable resource file
      READ(4,'(A220)') C221                                             ! read the hourly data part of the study title
      WRITE(5,'(1X,A220)') C221                                         ! print the hourly data file title
      WRITE(6,'(A220)') C221                                            ! print the hourly data file title
      WRITE(7,'(A220)') C221                                            ! print the hourly data file title
      READ(3,'(A220)',END=9) C221                                       ! read the demand multiplier and LFU
      READ(C221,*,ERR=9) DSF1,PLFU1,SLOLP1                              ! read the demand scale factor and the %LFU and the significant LOLP cutoff SLOLP
      READ(3,'(A220)') C221                                             ! read the number of VR
      READ(C221,*,END=9,ERR=9) NVS1                                     ! read the number of variable sources
      READ(3,'(A220)',END=9) C221                                       ! read the % capacity credit
      READ(C221,*,ERR=9) (PCTC1(I),I=1,NVS1)                            ! read the percent capacity credit for the reserve margin calculation
      READ(3,'(A220)',END=9) C221                                       ! read the scale factors for the VR
      READ(C221,*,ERR=9) (SF1(I),I=1,NVS1)                              ! read the scale factors for the variable resources
      DO 12 I=1,7                                                       ! LFU has 7 steps (load forecast uncertainty per Billington 1986)
  12  LFU1(I,2)=(I-4)*PLFU1/100.                                        ! create the delta loads for the 7 step table for a normal distribution
      READ(3,'(A220)') C221                                             ! skip this header for generators
* calculate the COPT, the capacity outage probability table F
      MAXGEN1=0                                                         ! MAXGEN is the sum of CAPA = total installed generation MW
      MXF1=0                                                            ! we store the maximum size of F that is needed for F1(x)>1.E-16
      RMGEN1=0.                                                         ! reserve margin generation used in the percent reserve calculation
      DO 1 I=1,99999
      READ(3,'(A220)',END=10) C221                                      ! read the generator data to the end of the file
      READ(C221,*,ERR=9,END=9) J,C2,C2,CAPA,RM,FOR,K,                   ! read bus#, genname, gentype, gen max MW, reserve margin %, forced outage rate, # extra states and then those states
     & (OUT1(L),PR1(L),L=3,K+2)
      PR1(1)=1.-FOR                                                     ! this is the up state which is not shifted and it has to be first in the PR array
      OUT1(1)=0                                                         ! the UP state at CAPA MW level has 0 MW outaged
      PR1(2)=FOR                                                        ! this is the total outage state where there is no power from the generator at all
      OUT1(2)=CAPA                                                      ! the entire generator CAPA capacity is outaged with Pr=FOR
      IF(K.GT.0) THEN                                                   ! set up the rest of the OUT,PR variables
        DO 6 L=3,K+2
        PR1(1)=PR1(1)-PR1(L)                                            ! additional states subtract from the probability of the UP state
        IF(PR1(1).LT.0.) GOTO 9                                         ! cannot have a negative UP probability
        OUT1(L)=CAPA-OUT1(L)                                            ! convert the availability MW to an outaged MW, this is what is convolved
        IF(OUT1(L).LE.0) GOTO 9
   6    CONTINUE
      ENDIF
      RMGEN1=RMGEN1+CAPA*RM/100.                                        ! rerate generator's capacities for the reserve margin calculation
      MAXGEN1=MAXGEN1+CAPA                                              ! MAXGEN is the total installed generation MW
      MG1=MAXGEN1                                                       ! we can start sweeping across F where F is going to be >0.
      IF(MG1.GT.190001) MG1=190001                                        ! its ok for the MAXGEN to exceed 190001
      DO 1 IX=MG1,0,-1                                                  ! sweep from right to left across F to convolve the next generator
      F1(IX)=F1(IX)*PR1(1)                                              ! scale down the UP state which is not shifted
      DO 23 L=2,K+2                                                     ! each of the rest of the states will be an outage state
      J=IX-OUT1(L)                                                      ! J will point to the shifted to the right generator outage state
      FJ=PR1(L)                                                         ! all F1(ix<0) = 1
      IF(J.GE.0) FJ=F1(J)*FJ                                            ! ix is => 0
      IF(FJ.LT.1.E-36) FJ=0.                                            ! this prevents an underflow error message
  23  F1(IX)=F1(IX) + FJ                                                ! down states are shifted to the right and added to the scaled down up state which was not moved
      IF(F1(IX).GE.1.E-16.AND.MXF1.LT.IX) MXF1=IX                       ! capture the largest IX needed, ignore smaller F
   1  CONTINUE
  10  WRITE(5,'(/12H MAX GENR  =,I11, 3H MW)') MAXGEN1                  ! MAXGEN is the installed generation capacity
      CLOSE(3)
* read the hourly data file
      DO 15 ITER=1,20                                                   ! if it can't find the correct demand in 20 attempts then stop
      IF(ITER.EQ.20) IP=1                                               ! print out something even if not converged
      REWIND(4)
      DO 14 I=1,14
  14  D1(I)=0.                                                          ! zero out all the dummy variables starting a new study
      READ(4,'(A220)') C221                                             ! read HDATA title again
      READ(4,'(A220)',END=9) C221
      IF(C221(1:10).NE.'YYYYMMDDHH')                                    ! read as an integer I the data is good through 2147123124 but fails on year 2148.
     &  WRITE(5,'(23HYYYYMMDDHH out of place)')                         ! just a check to make sure were are reading the data in the correct order
      IF(ITER.EQ.1) THEN
        WRITE(7,'(/11X,14HYear,MoDaHr D,8X,14HLOLP,  NETDEM,A206)')     ! new YYYYMMDDHH line header for OPH report
     &    C221(14:220)
      ENDIF
      VRC1=0.                                                           ! VRC will save the variable resource capacity MW credit
      DO 11 I=1,NVS1
      VRES1(I)=0.                                                       ! zero out the variable resource energy sum by source on significant days NSH1
  11  VRC1=VRC1+SF1(I)*PCTC1(I)/100.                                    ! MW variable resource capacity, we don't add uncertainty here since the actual data already contains the uncertainty
      IF(ITER.EQ.1) THEN
        WRITE(5,'(12H VARBL RES =,I11, 3H MW)') INT(VRC1+.5)            ! variable resource total MW capacity credit
        WRITE(5,'(12H GENR+VRES =,I11, 3H MW)') MAXGEN1+INT(VRC1+.5)    ! the sum of the GENR and VR capacities
        WRITE(5,'(12H MAX COPT  =,I11,13H (190000 MAX))') MXF1          ! shows how much of F1(x) array space was needed in this problem, COPT = capacity outage probability table
      ENDIF
      READ(4,'(A220)',END=9) C221                                       ! read the first line of hourly data
      D221=C221                                                         ! copy the first line of data to D221
      READ(C221,'(I4)') IFY                                             ! first year in HDATA
* repeat years as many times as there is annual data
      IYR=IFY-1
      NTH=0                                                             ! number of total hours
      DO 7 IY=1,9999                                                    ! simulate up to 9999 years of historical data
      IYR=IYR+1
      NSH1=0                                                            ! number of significant hours, where LOLP>SLOLP significant LOLP
      LOLEAM1=0.D0              ! these indices will be created         ! this is the annual sum of LOLP peaks occurring in the AM hours 1-12
      LOLEPM1=0.D0              ! and summed in 7 LFU steps             ! this is the annual sum of LOLP peaks occurring in the PM hours 13-24
      LOLEV1=0.D0                                                       ! loss of load events per year
      LOLH1=0.D0                                                        ! loss of load hours is the sum of every hour's LOLP for a year
      EUE1 =0.D0                                                        ! EUE (or EENS) is the expected unserved energy of expected energy not served
      ENGT1=0.D0                                                        ! this is the total energy served used in calculating the % unserved energy
      VRE1 =0.D0                                                        ! annual variable resource energy
      VREC1=0.D0                                                        ! annual variable resource energy load, dumped, or curtailed
* sweep through all the hours calculating the LOLP each hour and the LOLE and LOLH
      IHRS=0                                                            ! count the hours per day and reset to define a new day, capture the max LOLP
      IHB1OLD=0
      PLOLPAM1=0.                ! the lolps will be calculated for     ! PLOLPAM1 will be the peak AM period LOLP of each day if the AM has a peak
      PLOLPPM1=0.                ! each of the 7 steps and summed       ! PLOLPPM1 will be the peak PM period LOLP of each day if the PM has a peak
      PKDEM1=0.                 ! so only the lolp is affected by       ! capture the peak demand before renewables are applied
      PKNET1=0.                 ! the LFU                               ! capture the peak net demand after renewables are applied
      IH3=0                     ! the hour during the day, we do this separately here because the YYYYMMDDHH can contain leap days with a screwed up hour
      IOK=0                     ! IOK=1 means list this day in file 6
      DO 4 IH=1,9999                                                    ! assume more hours than actual and note change in YY as start of a new year
      NTH=NTH+1                                                         ! total number of hours
      NH=IH
      READ(C221(14:220),*,ERR=9) DEMD1,(VR1(I),I=1,NVS1)                ! read the hourly demand and variable sources, YYYYMMDDHH and D are just for our reference
      HD1=DEMD1*DSF1                                                    ! hourly MW demand is the first number read, the rest are variable sources
      IH3=IH3+1
      READ(C221,*) MW(23,IH3),MW(24,IH3)                                ! capture the YYYYMMDDHH in 23, D in 24, 22 net demand, 21 demand, VR in 1-20
      MW(21,IH3)=HD1+.5                                                 ! capture the MW demand for hour IH3
      IF(HD1.GT.PKDEM1) PKDEM1=HD1                                      ! capture the peak demand for this year before renewables are applied
      HD11=HD1                  ! the 7 step LFU will be applied to HD11! remember the native demand for this hour
      ENGT1=ENGT1+HD1           ! only in the LOLP lookup in F1(x)      ! this is the total energy of the original hourly demand
      IF(NVS1.GT.0) THEN        ! and not applied to other values       ! see if any variable sources are present
        DO 2 I=1,NVS1           ! everywhere the LOLP is used, the      ! if there are varible sources then loop through all of them
        HD1=HD1-VR1(I)*SF1(I)   ! the LFU will be carried forward       ! subtract the scaled variable source from the scaled hourly demand
   2    MW(I,IH3)=VR1(I)*SF1(I)+.5                                      ! capture the MW values of the VR this hour
      ENDIF
      IF(HD1.GT.0.) THEN
        MW(22,IH3)=HD1+.5
      ELSE
        MW(22,IH3)=HD1-.5
      ENDIF
      IF(HD1.LT.0.) THEN
        VREC1=VREC1-HD1                                                 ! remember the total renewable energy that has been dumped
        HD1=0.                                                          ! however, if the net hourly demand is negative, then set the demand to 0 MW
      ENDIF
      IF(HD1.GT.PKNET1) PKNET1=HD1                                      ! capture the net peak demand for this year after renewables are applied
      VRE1=VRE1+(HD11-HD1)                                              ! sum up the total variable source energy that has been applied to the demand
      LOLP1=0.D0                                                        ! getting ready to sum the LOLPs for the 7 LFU steps
      DO 13 L=1,7                                                       ! now we loop through all the LFU steps
      HD21=HD1+HD11*LFU1(L,2)                                           ! HD21 is a new modified demand that contains the load undertainty
      IF(HD21.LT.0.) HD21=0.                                            ! let's just avoid feeding negative load to the COPT, the LOLP is zero anyway
      IHD1=HD21                                                         ! this is the integer part of HD21 to the left of the decimal
      P=HD21-IHD1                                                       ! P is the fraction of MW < 1 MW greater than the integer HD1 MW
      IF(MAXGEN1-IHD1.LE.MXF1) THEN                                     ! assume F1(X>MXF)=0  MAXGEN minus integer part of the demand on the COPT
        D1(15)=0.D0                                                     ! sum up the unserved energy for this hour, D1(15) is just a dummy variable
        DO 3 I=MXF1,MAXGEN1-IHD1,-1                                     ! this loop is to sum up the unserved energy under the COPT
        FI=1.
        IF(I.GE.0) FI=F1(I)
   3    D1(15)=D1(15)+FI                                                ! 1 MW wide increments of load with F probability not served starting with the smallest of F
        IF(P.GT.0.) THEN                                                ! this is the small fraction of load < 1 MW but greater than the IHD1 integer MW load
          IHD1=IHD1+1                                                   ! pick up the LOLP for the next higher MW load level, its a stairstep
          FI=1.
          IF(MAXGEN1-IHD1.GE.0) FI=F1(MAXGEN1-IHD1)
          D1(15)=D1(15)+P*FI                                            ! and add on that bit of unserved energy
        ENDIF
        EUE1=EUE1+D1(15)*LFU1(L,1)                                      ! add on this hour's unserved energy D1(15) to the running sum EUE
        FI=1.
        IF(MAXGEN1-IHD1.GE.0) FI=F1(MAXGEN1-IHD1)
        LOLP1=LOLP1+FI*LFU1(L,1)                                        ! the LOLP is a lookup for the higher demand if P>0, this line works also for P=0
      ENDIF
  13  CONTINUE                                                          ! end of the LFU and LOLP calculations
      IF(LOLP1.GE.SLOLP1) THEN
        NSH1=NSH1+1                                                     ! a significant hour LOLP=>significant LOLP
        IOK=1                                                           ! OK remember this day is sgnificant for printing to OPH.CSV
        DO 22 I=1,NVS1
  22    VRES1(I)=VRES1(I)+VR1(I)*SF1(I)                                 ! sum the MW of VR for significant hours so we can average the MW of each VR during these hours
      ENDIF
      LOLP24(IH3,1)=LOLP1
      IF(IOK.EQ.1.AND.(IH3.EQ.24.OR.C221(9:10).EQ.'24')) THEN
        DO 21 I=1,24
        WRITE(G1,'(I10)') MW(23,I)
        IF(IP.EQ.1) WRITE(7,'(A4,2H, A6,I4,1H,F8.6,1H,21(I9,1H,))')
     &    G1(1:4),G1(5:10),MW(24,I),LOLP24(I,1),MW(22,I),MW(21,I),
     &    (MW(J,I),J=1,NVS1)
  21    CONTINUE
      ENDIF
      IF(IH3.EQ.24.OR.C221(9:10).EQ.'24') THEN
        IOK=0
        IH3=0
      ENDIF
      LOLH1=LOLH1+LOLP1                                                 ! calculate the annual loss of load hours
      IHRS=IHRS+1                                                       ! this is the hour of the day
      IF(IHRS.LE.12) THEN                                               ! the AM period
        IF(LOLP1.GT.PLOLPAM1) THEN
          PLOLPAM1=LOLP1                                                ! capture the max LOLP1 each day
          IHA1=IHRS                                                     ! remember the hour of the peak AM LOLP
        ENDIF
      ELSE                                                              ! the else will be hours 13-24
        IF(LOLP1.GT.PLOLPPM1) THEN
          PLOLPPM1=LOLP1                                                ! capture the max LOLP2 each day
          IHB1=IHRS                                                     ! remember the hour of the peak PM LOLP
        ENDIF
      ENDIF
      IF(IHRS.EQ.24) THEN                                               ! we are at the end of a day
        IF(IHB1-IHA1.LE.6.OR.24-IHB1OLD+IHA1.LE.6) THEN                 ! peak LOLPs are too close together to treat as separate events
          IF(PLOLPPM1.GE.PLOLPAM1) PLOLPAM1=0.
          IF(PLOLPAM1.GE.PLOLPPM1) THEN
            IHB1=15                                                     ! make sure its not close to midnight is all
            PLOLPPM1=0.
          ENDIF
        ENDIF
        LOLEV1=LOLEV1+PLOLPAM1+PLOLPPM1                                 ! loss of load events can count up to two events per day if they meet the above tests
        IF(PLOLPPM1.GE.PLOLPAM1) PLOLPAM1=0.                            ! this goes ahead and resets the AM and PM max LOLPs so there is only one per day
        IF(PLOLPAM1.GE.PLOLPPM1) PLOLPPM1=0.
        LOLEAM1=LOLEAM1+PLOLPAM1                                        ! the LOLEAM1 is the sum of daily maximum AM LOLPs
        LOLEPM1=LOLEPM1+PLOLPPM1                                        ! the LOLEPM1 is the sum of daily maximum PM LOLPs
        PLOLPAM1=0.                                                     ! reset PLOLPAM1 for a new day
        PLOLPPM1=0.                                                     ! reset PLOLPPM1 for a new day
        IHRS=0                                                          ! reset the hours counter for a new day
        IHB1OLD=IHB1                                                      ! this it the hour of max LOLP in the PM of the previous day
      ENDIF
      C221=' '
      READ(4,'(A220)',END=5) C221                                       ! read a new line of data or exit to the final report
      IF(C221(1:4).NE.D221(1:4)) GOTO 5                                 ! we must have started a new year if the YY is different, go to the report
      D221=C221                                                         ! copy the line of data to D221 for this hour
   4  CONTINUE                                                          ! end of the hour loop, do the next hour, which we never reach the end of this loop
   5  NY=IY                                                             ! remember the number of years
      IF(IP.EQ.1) THEN
        WRITE(5,'(/I5,9H RESULTS:)') IYR
        WRITE(5,'(12H PERIOD    =,I11,6H HOURS)') NH
        WRITE(5,'(12H PEAK DEMD =,F11.3,3H MW)') PKDEM1
        RM=(RMGEN1+VRC1)/PKDEM1*100.-100.                               ! reserve margin calculation
        WRITE(5,'(12H RESERVE   =,F11.1,2H %)') RM
        WRITE(5,'(12H LOAD ENGY =,F11.0,4H GWh)') ENGT1/1000.
        WRITE(5,'(12H LOAD FACT =,F11.3,2H %)') 100.*ENGT1/(NH*PKDEM1)
        WRITE(5,'(12H PEAK NETD =,F11.3,13H MW (DEMD-VR))') PKNET1
        WRITE(5,'(12H VR E USED =,F11.0,4H GWh)') VRE1/1000.
        WRITE(5,'(12H VR E LOST =,F11.0,4H GWh)') VREC1/1000.
        WRITE(5,'(14H Indices for a,F6.2,6H% LFU:)') PLFU1
        WRITE(5,'(12H LOLE(AM)  =,F11.6,4H d/y)') LOLEAM1               ! the AM LOLE
        WRITE(5,'(12H LOLE(PM)  =,F11.6,4H d/y)') LOLEPM1               ! the PM LOLE
        WRITE(5,'(12H LOLE      =,F11.6,4H d/y)') LOLEAM1+LOLEPM1       ! LOLE = 1.368863 which agrees exactly with the 1986 paper.
        WRITE(5,'(12H LOLEV **  =,F11.6,9H events/y)') LOLEV1           ! loss of load events
        WRITE(5,'(12H LOLEMW    =,F11.0,3H MW)') EUE1/LOLH1             ! the expected MW for loss of load
        WRITE(5,'(12H LOLH      =,F11.6,4H h/y)') LOLH1                 ! LOLH =   9.394175 which agrees exactly with the 1986 paper.
        WRITE(5,'(12H LOLH/event=,F11.6,8H h/event)') LOLH1/LOLEV1      ! duration of loss of load in hours per event
        WRITE(5,'(12H EUE MWh   =,F11.0,4H MWh)') EUE1
        WRITE(5,'(12H EUE ppm   =,F11.2,7H pu ppm)') EUE1/ENGT1*1.E6
        WRITE(5,'(12H EUE %     =,F11.6,2H %)') EUE1/ENGT1*100.         ! % unserved energy, .007690 is consistent with EUE of 1.176 in the 1986 paper
        WRITE(5,'(6H LOLP>,1PE5.0E1,1H=,I11  ,4H hrs)') SLOLP1,NSH1     ! significant LOLP and number of hours with significant LOLPs
      ENDIF
      D1(1)=D1(1)+PKDEM1
      D1(2)=D1(2)+ENGT1/1000.
      D1(3)=D1(3)+100.*ENGT1/(NH*PKDEM1)
      D1(4)=D1(4)+PKNET1
      D1(5)=D1(5)+VRE1/1000.
      D1(6)=D1(6)+VREC1/1000.
      D1(7)=D1(7)+LOLEAM1
      D1(8)=D1(8)+LOLEPM1
      D1(9)=D1(9)+LOLEV1
      D1(10)=D1(10)+LOLH1
      D1(11)=D1(11)+EUE1
      D1(12)=D1(12)+ENGT1
      D1(13)=D1(13)+NSH1                                                ! total number of significant hours for the entire period
      D1(14)=D1(14)+RM                                                  ! reserve margin calculation
      IF(C221(1:3).EQ.'end') GOTO 8                                     ! we reached the end of the datain file
      D221=C221                                                         ! remember C221 for the new year set of data
   7  CONTINUE
   8  LOLEAM1=(D1(7)+D1(8))/NY
      IF(NY.GT.1.AND.IP.EQ.1) THEN
        WRITE(5,'(/16H AVERAGE VALUES:)')
        WRITE(5,'(12H PERIOD    =,I11,6H HOURS)') NTH/NY
        WRITE(5,'(12H PEAK DEMD =,F11.3,3H MW)')  D1(1)/NY
        WRITE(5,'(12H RESERVE   =,F11.1,2H %)') D1(14)/NY
        WRITE(5,'(12H LOAD ENGY =,F11.0,4H GWh)') D1(2)/NY
        WRITE(5,'(12H LOAD FACT =,F11.3,2H %)')   D1(3)/NY
        WRITE(5,'(12H PEAK NETD =,F11.3,13H MW (DEMD-VR))') D1(4)/NY
        WRITE(5,'(12H VR E USED =,F11.0,4H GWh)') D1(5)/NY
        WRITE(5,'(12H VR E LOST =,F11.0,4H GWh)') D1(6)/NY
        WRITE(5,'(14H Indices for a,F6.2,6H% LFU:)') PLFU1
        WRITE(5,'(12H LOLE(AM)  =,F11.6,4H d/y)') D1(7)/NY
        WRITE(5,'(12H LOLE(PM)  =,F11.6,4H d/y)') D1(8)/NY
        WRITE(5,'(12H LOLE      =,F11.6,4H d/y)') LOLEAM1
        WRITE(5,'(12H LOLEV **  =,F11.6,9H events/y)') D1(9)/NY
        WRITE(5,'(12H LOLEMW    =,F11.0,3H MW)')  D1(11)/D1(10)
        WRITE(5,'(12H LOLH      =,F11.6,4H h/y)') D1(10)/NY
        WRITE(5,'(12H LOLH/event=,F11.6,8H h/event)') D1(10)/D1(9)
        WRITE(5,'(12H EUE MWh   =,F11.0,4H MWh)') D1(11)/NY
        WRITE(5,'(12H EUE ppm   =,F11.2,7H pu ppm)') D1(11)/D1(12)*1.E6
        WRITE(5,'(12H EUE %     =,F11.6,2H %)')   D1(11)/D1(12)*100.
        WRITE(5,'(6H LOLP>,1PE5.0E1,1H=,I11  ,7H hrs/yr)')
     &    SLOLP1,INT(D1(13)+.5)/NY                                      ! significant LOLP and total study period hours with significant LOLPs
      ENDIF
      IF(JS.EQ.0.AND.TLOLE1.GT.0.) THEN
        WRITE(*,'(/32HS   = step change logic for DSF1)')
        WRITE(*,'(26HDSF1 = demand scale factor)')
        WRITE(*,'(26HDDSF = per unit delta DSF1)')
        WRITE(*,'(32HS   LOLE d/y     DSF1       DDSF)')
        JS=1
      ENDIF
      IF(IP.EQ.1.AND.NVS1.GT.0) THEN
        WRITE(5,*) ' '
        WRITE(5,*)   'Variable Resource Capacity Credits'
        WRITE(5,'(29H Max Net Demand hrs for LOLP>,1PE5.0E1,1H:)')SLOLP1
        WRITE(5,'(/20(F6.1,1H%))')(100.*VRES1(I)/D1(13)/SF1(I),I=1,NVS1)
      ENDIF
      IF(TLOLE1.GT.0.) WRITE(*,'(I1,F11.7,2X,G12.7,F6.3)')
     &  JS,LOLEAM1,DSF1,DDSF
      IF(IP.EQ.1) GOTO 20                                               ! skip iterative target LOLE or we are ready to wrap it up
      IF(ABS(TLOLE1-LOLEAM1).LE..0001*TLOLE1) THEN                      ! meets an excellent LOLE result
        IP=1                                                            ! make another pass so printout can happen
        GOTO 15
      ENDIF
      IF(ITER.EQ.1) THEN                                                ! first iteration we have to guess a delta step
        DSF0=DSF1                                                       ! remember where we came from on DSF
        LOLE0=LOLEAM1
        IF(TLOLE1.GE.LOLEAM1) THEN
          DSF1=DSF1*(1.+DDSF)                                           ! first iteration jump up 2% if too low
          JS=2
        ELSE
          DSF1=DSF1*(1.-DDSF)                                           ! first iteration jump down 2% if too high
          JS=3
        ENDIF                                                           ! notice we did not reduce the 2% step size because we may have to take another 2% step
        GOTO 15
      ENDIF
      IF(ABS(LOLEAM1-LOLE0).LE..00001*TLOLE1) THEN                      ! the change in LOLE was small on this iteration so wrap things up
        IP=1                                                            ! make another pass so the data can be printed out
        GOTO 15
      ENDIF
      IF(ABS(TLOLE1-LOLE0).LE..2*TLOLE1.OR.ABS(TLOLE1-LOLEAM1).LE.
     &  .2*TLOLE1) THEN
        D1(1) = (DSF1-DSF0)*(TLOLE1-LOLE0)/(LOLEAM1-LOLE0) + DSF0       ! use a Newton convergence when one end is close enough to the solution
        DSF0 = DSF1
        LOLE0= LOLEAM1
        DSF1  = D1(1)
          JS=4
        GOTO 15
      ENDIF
      IF(TLOLE1.LT.LOLEAM1.AND.TLOLE1.GT.LOLE0) THEN
        DDSF=DDSF/2.
        DSF1=DSF1*(1.-DDSF)
          JS=5
        GOTO 15
      ENDIF
      IF(TLOLE1.GT.LOLEAM1.AND.TLOLE1.LT.LOLE0) THEN
        DDSF=DDSF/2.
        DSF1=DSF1*(1.+DDSF)
          JS=6
        GOTO 15
      ENDIF
      DSF0 = DSF1
      LOLE0= LOLEAM1
      IF(TLOLE1.GT.LOLEAM1.AND.TLOLE1.GT.LOLE0) THEN
        DSF1=DSF1*(1.+DDSF)                                             ! load is too low increase the load
          JS=7
        GOTO 15
      ENDIF
      IF(TLOLE1.LT.LOLEAM1.AND.TLOLE1.LT.LOLE0) THEN
        DSF1=DSF1*(1.-DDSF)                                             ! load is too high decrease the load
          JS=8
        GOTO 15
      ENDIF
  15  CONTINUE
  20  WRITE(*,*)' '
      WRITE(5,*)' '
      WRITE(5,*)'** LOLE counts events per 24 hours and LOLEV in this'
      WRITE(5,*)'   program counts events per 12 hours.  Sequential MC'
      WRITE(5,*)'   in different programs produces different counts of'
      WRITE(5,*)'   events making it impossible to get an exact count.'
      WRITE(5,*)'   LOLE, LOLH, EUE are exact value points in 0 time.'
      CLOSE(5)
      OPEN(5,FILE='OP.TXT')                                             ! open text output report file so we can read the numbers and write them to OP.csv
      WRITE(6,'(/A192,1PE5.0E1,4H hrs)') '          YEAR,  PKDEMD,     %
     &RESV,LoadGWh,%LDFact,PKnetMW,    VRGWh,      VRlost,        %LFU,L
     &OLE(AM),LOLE(PM),LOLE(d/y),LOLEV(#/y),LOLEMW,LOLH(h/y),LOLH(h/e),E
     &UEMWh,   EUEppm,    EUE%,LOLP>',SLOLP1
      READ(5,'(//////////1X,A4)') G1
  18  READ(5,'(/1X,A4/7(/12X,F11.0)/14X,F6.0,11(/12X,F11.0))',ERR=19)
     & G1,D1
      WRITE(6,'(A4,1H,F11.3,1H,F11.1,1H,F11.0,1H,F11.3,1H,F11.3,1H,F11.0
     &,1H,F11.0,1H,F11.2,1H,F11.6,1H,F11.6,1H,F11.6,1H,F11.6,1H,F11.0,1H
     &,F11.6,1H,F11.6,1H,F11.0,1H,F11.2,1H,F11.6,1H,F11.0,1H,)') G1,D1
      GOTO 18
  19  CLOSE(5)
      CLOSE(6)
      CLOSE(7)
      WRITE(*,*) 'SEE OP.TXT OP.CSV OPH.CSV FILES'
      WRITE(*,*) 'PRESS ENTER TO END THIS PROGRAM'
      READ(*,'(A1)') C221
      STOP
   9  WRITE(*,'(16H ERROR READING: ,A220)') C221
      WRITE(*,*) 'PRESS ENTER TO END THIS PROGRAM'
      READ(*,'(A1)') C221
      STOP
  16  WRITE(*,*) 'OPEN FILE ERROR: ',G1
      STOP
  17  WRITE(*,*) 'OPEN FILE ERROR: ',H1
      STOP
      END
